﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Grid_PartialViews.Controllers
{
    public class HomeController : Controller
    {
        // GET: Home
        public ActionResult Index()
        {
            return View();
        }

		public MvcHtmlString GetViews()
		{
			List<Item> items = new List<Item>();
			for (int i = 0; i < 20; i++)
			{
				items.Add(new Item() { PersonId = i, FirstName = "Name" + 1 });
			}

			string data1 = RenderPartialView(ViewData, ControllerContext, TempData, "GridView", items.AsQueryable());
			string data2 = RenderPartialView(ViewData, ControllerContext, TempData, "EmptyView", items.AsQueryable());
			JsonResult res = new JsonResult();
			res.Data= data1+data2;
			res.JsonRequestBehavior = JsonRequestBehavior.AllowGet;
			return new MvcHtmlString(data1 + data2);
		}

		public static string RenderPartialView(ViewDataDictionary viewData, ControllerContext context, TempDataDictionary tempData, string viewName, object model)
		{
			viewData.Model = model;

			using (System.IO.StringWriter writer = new System.IO.StringWriter())
			{
				ViewEngineResult viewResult = ViewEngines.Engines.FindPartialView(context, viewName);
				ViewContext viewContext = new ViewContext(context, viewResult.View, viewData, tempData, writer);
				viewResult.View.Render(viewContext, writer);

				return writer.GetStringBuilder().ToString();
			}
		}

    }
}